import .connectives
import .leibniz
import .logic
axiom nat.nat : Type.
constant nat.S : (nat.nat) -> nat.nat.
constant nat.filter_nat_type : forall (return : Type) , ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((connectives.equal) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n))).
theorem nat.eq_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n))) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n)))) ((((@nat.axiom_filter_nat_type_S) (return_type)) (return)) (n)).
theorem nat.sym_eq_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((return) (((nat.S) ) (n)))) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n))) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n)))) ((((@nat.eq_filter_nat_type_S) (return_type)) (return)) (n)).
constant nat.plus : (nat.nat) -> (nat.nat) -> nat.nat.
constant nat.times : (nat.nat) -> (nat.nat) -> nat.nat.
constant nat.times_body : (nat.nat) -> (nat.nat) -> nat.nat.
axiom nat.axiom_times : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.times) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n)).
theorem nat.eq_times : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.times) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n)) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.times) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n))) ((@nat.axiom_times) (n)).
theorem nat.sym_eq_times : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n))) (((nat.times) ) (n)) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.times) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n))) ((@nat.eq_times) (n)).
axiom nat.axiom_times_body_S : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.times_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , (((nat.plus) ) (m)) ((((nat.times) ) (n)) (m))).
theorem nat.eq_times_body_S : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , (((nat.plus) ) (m)) ((((nat.times) ) (n)) (m))) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , (((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((@nat.axiom_times_body_S) (n)).
theorem nat.sym_eq_times_body_S : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (fun (m : nat.nat) , (((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) (((nat.times_body) ) (((nat.S) ) (n))) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , (((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((@nat.eq_times_body_S) (n)).
theorem nat.times_Sn_m : forall (n:nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((((nat.times) ) (((nat.S) ) (n))) (m)) := fun (n : nat.nat) , fun (m : nat.nat) , (((@nat.sym_eq_times) (((nat.S) ) (n))) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((y) (m)))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((y) (m)))) ((((@nat.sym_eq_times_body_S) (n)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((y) (m)))) (((@logic.refl_) (nat.nat)) ((((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))))).
